var chunkSize = 50;

$('#template_store_tabs a').click(function (e) {
    e.preventDefault()
    $(this).tab('show')
})

// Submit Media Files Form
$( "#mediaFilesForm" ).submit(function( event ) {

    // Stop form from submitting normally
    event.preventDefault();

    var key = $("input[name='key']").val();

    var url = $( this ).attr( "action" );
    var selectedFolders = [];
    $.each($("input[name='folderPath']:checked"), function(){
        selectedFolders.push($(this).val());
    });

    if(selectedFolders.length > 0) {
        // console.log( selectedFolders.length )
        var images;

        $('#mediaFilesForm').block({
            message: $('#throbber_media'),
        });
        resetResultsUi();

        // get all images
        $.ajax({
            type: 'POST',
            url: url,
            data: {folderPath: selectedFolders, action: "getImages"},
            async: false
        }).success(function( data ) {
            images = $.parseJSON(data);
        });

        // split images into chunks
        var chunkedImages =  chunkArray(images, chunkSize);
        var countConvertedImages = 0;
        var failedImages = [];
        var noChanges;

        // prepare data
        function sendDataToServer(image) {
            return $.ajax({
                    type: 'POST',
                    url: url,
                    data: {images: image, key: key},
                })
        }

        // send data in chunks to the server.
        $.each(chunkedImages, function(index, image) {
            sendDataToServer(image).done(function(data) {
                var dataObj = $.parseJSON(data)
                var failedImagesTmp = dataObj.failedImages;
                noChanges = dataObj.noChanges
                countConvertedImages += parseInt(dataObj.optImages);
                $.each(failedImagesTmp, function(index, img) {
                    failedImages.push(img);
                });

                $(document).one("ajaxStop", function() {
                    if( index === chunkedImages.length-1 ) {
                        if( noChanges == "true" ){
                            $('.media_result .alert.alert-info').fadeToggle();
                        }
                        if( countConvertedImages > 0) {
                            $('.media_result .result_opt_images').text(countConvertedImages);
                            $('.media_result .alert.alert-success').fadeToggle();
                        }
                        if ( failedImages.length > 0 ){
                            $.each(failedImages, function(index, img) {
                                $('.media_result .result_images_not_found').append( "<p>"+img+"</p>" );
                            })
                            $('.media_result .alert.alert-warning').fadeToggle();
                        }

                        $('#mediaFilesForm').trigger("reset");
                        updateCredits();
                        $('#mediaFilesForm').unblock();
                    }
                });
            }).fail(function() {
                $(".media_result").html('<div class="alert alert-danger alert-dismissible" role="alert">' +
                    '<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>' +
                    "Task failed! Please try again." +
                    '</div>');
                $('#mediaFilesForm').trigger("reset");
                updateCredits();
                $('#mediaFilesForm').unblock();
            });
        });
    }
});


// Submit Template Files Form


$( "#templateFilesForm" ).submit(function( event ) {

    // Stop form from submitting normally
    event.preventDefault();

    var key = $("input[name='key']").val();

    var url = $( this ).attr( "action" );
    var selectedFolders = [];
    $.each($("input[name='folderPath']:checked"), function(){
        selectedFolders.push($(this).val());
    });

    if(selectedFolders.length > 0) {
        // console.log( selectedFolders.length )
        var images;

        $('#template_data_tab').block({
            message: $('#throbber_tpl'),
        });
        resetResultsUi();

        // get all images
        $.ajax({
            type: 'POST',
            url: url,
            data: {folderPath: selectedFolders, action: "getImages"},
            async: false
        }).success(function( data ) {
            images = $.parseJSON(data);
        });

        // split images into chunks
        var chunkedImages =  chunkArray(images, chunkSize);
        var countConvertedImages = 0;
        var failedImages = [];
        var noChanges;

        // prepare data
        function sendDataToServer(image) {
            return $.ajax({
                type: 'POST',
                url: url,
                data: {images: image, key: key},
            })
        }

        // send data in chunks to the server.
        $.each(chunkedImages, function(index, image) {
            sendDataToServer(image).done(function(data) {
                var dataObj = $.parseJSON(data)
                var failedImagesTmp = dataObj.failedImages;
                noChanges = dataObj.noChanges
                countConvertedImages += parseInt(dataObj.optImages);
                $.each(failedImagesTmp, function(index, img) {
                    failedImages.push(img);
                });

                $(document).one("ajaxStop", function() {
                    if( index === chunkedImages.length-1 ) {
                        if( noChanges == "true" ){
                            $('.template_result .alert.alert-info').fadeToggle();
                        }
                        if( countConvertedImages > 0) {
                            $('.template_result .result_opt_images').text(countConvertedImages);
                            $('.template_result .alert.alert-success').fadeToggle();
                        }
                        if ( failedImages.length > 0 ){
                            $.each(failedImages, function(index, img) {
                                $('.template_result .result_images_not_found').append( "<p>"+img+"</p>" );
                            })
                            $('.template_result .alert.alert-warning').fadeToggle();
                        }

                        $('#templateFilesForm').trigger("reset");
                        updateCredits();
                        $('#template_data_tab').unblock();
                    }
                });
            }).fail(function() {
                $(".template_result").html('<div class="alert alert-danger alert-dismissible" role="alert">' +
                    '<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>' +
                    "Task failed! Please try again." +
                    '</div>');
                $('#templateFilesForm').trigger("reset");
                updateCredits();
                $('#template_data_tab').unblock();
            });
        });
    }
});


// $( ".templateFilesForm" ).submit(function( event ) {
//     // Stop form from submitting normally
//     event.preventDefault();
//
//     var key = $("input[name='key']").val();
//
//     url = $( this ).attr( "action" );
//     var selectedFolders = [];
//     $.each($("input[name='folderPath']:checked"), function(){
//         selectedFolders.push($(this).val());
//     });
//
//     // Send the data using post
//     if(selectedFolders.length > 0) {
//         var posting = $.post(url, {folderPath: selectedFolders, key: key});
//         // $.blockUI({ message: $('#throbber') });
//         $('#template_data_tab').block({
//             message: $('#throbber_tpl'),
//         });
//
//         // Put the results in a div
//         posting.done(function( data ) {
//             // console.log(data);
//             $( ".template_result" ).html( '<div class="alert alert-info alert-dismissible" role="alert">'+
//                 '<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>'+
//                     data+
//                 '</div>' );
//             $('.templateFilesForm').trigger("reset");
//             updateCredits();
//             $('#template_data_tab').unblock();
//         });
//     }
// });

function chunkArray(myArray, chunk_size){
    var results = [];
    while (myArray.length) {
        results.push(myArray.splice(0, chunk_size));
    }
    return results;
}

function resetResultsUi() {
    $('.media_result .alert.alert-info').hide();
    $('.media_result .alert.alert-success').hide();
    $('.media_result .alert.alert-warning').hide();
    $('.media_result .result_images_not_found').text("");

    $('.template_result .alert.alert-info').hide();
    $('.template_result .alert.alert-success').hide();
    $('.template_result .alert.alert-danger').hide();
    $('.template_result .result_images_not_found').text("");
}